//+------------------------------------------------------------------+
//|                         Fx Snipper's Ergodic CCI Trigger + alert |
//+------------------------------------------------------------------+
#property  copyright "mladen"
#property  link      "mladenfx@gmail.com"

#property  indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  DimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    pq              =  2;
extern int    pr              = 10;
extern int    ps              =  5;
extern int    trigger         =  3;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsNotification = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;


double buffUp[];
double buffDo[];
double buffNe[];
double ErgoCCI[];
double MainCCI[];
double buffer[][8];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,buffUp);  SetIndexLabel(0,"Ergodic CCI - up");      SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffDo);  SetIndexLabel(1,"Ergodic CCI - down");    SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffNe);  SetIndexLabel(1,"Ergodic CCI - neutral"); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ErgoCCI);
   SetIndexBuffer(4,MainCCI);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}

//
//
//
//
//

#define mtm    0
#define absmtm 1
#define var1   2
#define var2   3
#define var2a  4
#define var2b  5
#define var2c  6
#define var2d  7

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { buffUp[0] = limit+1; return(0); }
         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  buffUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"",pq,pr,ps,trigger,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,0,y);
                  buffDo[i] = iCustom(NULL,timeFrame,indicatorFileName,"",pq,pr,ps,trigger,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,1,y);
                  buffNe[i] = iCustom(NULL,timeFrame,indicatorFileName,"",pq,pr,ps,trigger,alertsOn,alertsOnCurrent,alertsMessage,alertsNotification,alertsSound,alertsEmail,2,y);
            }
            return(0);
         }
         if (ArrayRange(buffer,0) != Bars) ArrayResize(buffer,Bars);
 

   //
   //
   //
   //
   //
   

   double alphaPq = 2.0/(1.0+pq);
   double alphaPr = 2.0/(1.0+pr);
   double alphaPs = 2.0/(1.0+ps);
   double alphaTrigger = 2.0/(1.0+trigger);
   
   for(i=limit,r=Bars-limit-1; i >=0; i--,r++) 
   {
      buffer[r][mtm]    = Close[i]-Close[i+1];
      buffer[r][absmtm] = MathAbs(buffer[r][mtm]);
      buffer[r][var1]   = buffer[r-1][var1]  + alphaPq*(buffer[r][mtm]   -buffer[r-1][var1]);
      buffer[r][var2]   = buffer[r-1][var2]  + alphaPr*(buffer[r][var1]  -buffer[r-1][var2]);
      buffer[r][var2a]  = buffer[r-1][var2a] + alphaPq*(buffer[r][absmtm]-buffer[r-1][var2a]);
      buffer[r][var2b]  = buffer[r-1][var2b] + alphaPr*(buffer[r][var2a] -buffer[r-1][var2b]);
      buffer[r][var2c]  = buffer[r-1][var2c] + alphaPs*(buffer[r][var2]  -buffer[r-1][var2c]);
      buffer[r][var2d]  = buffer[r-1][var2d] + alphaPs*(buffer[r][var2b] -buffer[r-1][var2d]);
      if (buffer[r][var2d]!=0)
            ErgoCCI[i] = (500*buffer[r][var2c]/buffer[r][var2d]);
      else  ErgoCCI[i] = 0;
            MainCCI[i] = MainCCI[i+1] + alphaTrigger*(ErgoCCI[i]-MainCCI[i+1]);

      //
      //
      //
      //
      //
      
      buffUp[i] = EMPTY_VALUE;
      buffDo[i] = EMPTY_VALUE;
      buffNe[i] = EMPTY_VALUE;
         if (ErgoCCI[i] >MainCCI[i]) buffUp[i] = 1;
         if (ErgoCCI[i] <MainCCI[i]) buffDo[i] = 1;
         if (ErgoCCI[i]==MainCCI[i]) buffNe[i] = 1;
   }
   if (alertsOn)
      {
         if (alertsOnCurrent)
         {
            if(MainCCI[1] <= ErgoCCI[1] && MainCCI[0] > ErgoCCI[0]) doAlert("short");
            if(MainCCI[1] >= ErgoCCI[1] && MainCCI[0] < ErgoCCI[0]) doAlert("long");
         }
         else
         {
            if(MainCCI[2] <= ErgoCCI[2] && MainCCI[1] > ErgoCCI[1]) doAlert("short");
            if(MainCCI[2] >= ErgoCCI[2] && MainCCI[1] < ErgoCCI[1]) doAlert("long");
         }            
      }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(timeFrameToString(Period())+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ergodic ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ergodic crossing"),message);
             if (alertsNotification) SendNotification(StringConcatenate(Symbol(),"ergodic crossing "+message));
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}